//Albert Gural
//Started: 	06/26/10
//v1.0: 		07/11/10
//Password Program v1.0

//for testing purposes, use the following login:
//username: test
//password: 123 testing

   import java.io.*;
   import java.awt.*;
   import java.util.*;
   import java.lang.*;
   import javax.swing.*;
   import javax.imageio.*;
   import java.awt.event.*;
   import javax.swing.event.*;
	import javax.swing.border.*;
   import java.awt.datatransfer.*;
   import javax.swing.plaf.basic.*;
   import javax.swing.JOptionPane.*;
	import javax.swing.BorderFactory.*;

    public class PasswordDriver
   {
       public static void main(String[] args) throws Exception
      {
         JFrame frame = new JFrame("Password Encryptor");
         frame.setSize(500, 555);
         frame.setResizable(false);
         frame.setIconImage(ImageIO.read(new File("password encryptor icon.png")));
         frame.setLocation(300, 200);
         frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
         PasswordGUI mainPane = new PasswordGUI();
         passMenuBar mainBar = new passMenuBar(mainPane);
         frame.setJMenuBar(mainBar);
         frame.setContentPane(mainPane);
         frame.setVisible(true);
         System.out.println("Running Password Encryptor!");
			
         while(true)
            mainPane.run();
      }
   }
	
    class passMenuBar extends JMenuBar
   {
      private PasswordGUI myPane;
      private TextTransfer textTransfer = new TextTransfer();
   	
       public passMenuBar(PasswordGUI pane)
      {
         super();
         myPane = pane;
         setBackground(Color.blue);
      	
      	
         JMenu fileMenu = new JMenu("File");
         fileMenu.setForeground(Color.white);
         fileMenu.setBackground(Color.blue);
         fileMenu.setMnemonic(KeyEvent.VK_F);
         fileMenu.getAccessibleContext().setAccessibleDescription("File Operations");
         add(fileMenu);
      	
         JMenuItem newFileItem = new JMenuItem("New...", KeyEvent.VK_N);
         newFileItem.setForeground(Color.white);
         newFileItem.setBackground(Color.blue);
         newFileItem.getAccessibleContext().setAccessibleDescription("Create New File");
         newFileItem.addActionListener(new newFileListener());
         fileMenu.add(newFileItem);
      	
         JMenuItem openFileItem = new JMenuItem("Open...", KeyEvent.VK_O);
         openFileItem.setForeground(Color.white);
         openFileItem.setBackground(Color.blue);
         openFileItem.getAccessibleContext().setAccessibleDescription("Open File");
         openFileItem.addActionListener(new openFileListener());
         fileMenu.add(openFileItem);
      	
         JMenuItem lastFileItem = new JMenuItem("Open Last", KeyEvent.VK_L);
         lastFileItem.setForeground(Color.white);
         lastFileItem.setBackground(Color.blue);
         lastFileItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R, InputEvent.CTRL_MASK));
         lastFileItem.getAccessibleContext().setAccessibleDescription("Open Last File");
         lastFileItem.addActionListener(new lastFileListener());
         fileMenu.add(lastFileItem);
      	      	
         JMenuItem deleteFileItem = new JMenuItem("Delete...", KeyEvent.VK_D);
         deleteFileItem.setForeground(Color.white);
         deleteFileItem.setBackground(Color.blue);
         deleteFileItem.getAccessibleContext().setAccessibleDescription("Delete File");
         deleteFileItem.addActionListener(new deleteFileListener());
         fileMenu.add(deleteFileItem);
      	
         fileMenu.addSeparator();
      	
         JMenuItem saveFileItem = new JMenuItem("Save...", KeyEvent.VK_S);
         saveFileItem.setForeground(Color.white);
         saveFileItem.setBackground(Color.blue);
         saveFileItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, InputEvent.CTRL_MASK));
         saveFileItem.getAccessibleContext().setAccessibleDescription("Save File");
         saveFileItem.addActionListener(new saveFileListener());
         fileMenu.add(saveFileItem);
      	
         JMenuItem saveAsFileItem = new JMenuItem("Save As...", KeyEvent.VK_A);
         saveAsFileItem.setForeground(Color.white);
         saveAsFileItem.setBackground(Color.blue);
         saveAsFileItem.getAccessibleContext().setAccessibleDescription("Save File As");
         saveAsFileItem.addActionListener(new saveAsFileListener());
         fileMenu.add(saveAsFileItem);
      	
         fileMenu.addSeparator();
      	
         JMenuItem exitFileItem = new JMenuItem("Exit", KeyEvent.VK_X);
         exitFileItem.setForeground(Color.white);
         exitFileItem.setBackground(Color.blue);
         exitFileItem.getAccessibleContext().setAccessibleDescription("Exit Program");
         exitFileItem.addActionListener(new exitFileListener());
         fileMenu.add(exitFileItem);
      	
      	
         JMenu editMenu = new JMenu("Edit");
         editMenu.setForeground(Color.white);
         editMenu.setMnemonic(KeyEvent.VK_E);
         editMenu.getAccessibleContext().setAccessibleDescription("Edit Operations");
         add(editMenu);
      	
         JMenuItem copyItem = new JMenuItem("Copy Entry", KeyEvent.VK_C);
         copyItem.setForeground(Color.white);
         copyItem.setBackground(Color.blue);
         copyItem.getAccessibleContext().setAccessibleDescription("Copy Entire Entry");
         copyItem.addActionListener(new copyListener());
         editMenu.add(copyItem);	
      	
         JMenuItem cutItem = new JMenuItem("Cut Entry", KeyEvent.VK_X);
         cutItem.setForeground(Color.white);
         cutItem.setBackground(Color.blue);
         cutItem.getAccessibleContext().setAccessibleDescription("Cut Entire Entry");
         cutItem.addActionListener(new cutListener());
         editMenu.add(cutItem);	
      	
         JMenuItem pasteItem = new JMenuItem("Paste Entry", KeyEvent.VK_V);
         pasteItem.setForeground(Color.white);
         pasteItem.setBackground(Color.blue);
         pasteItem.getAccessibleContext().setAccessibleDescription("Paste Entire Entry");
         pasteItem.addActionListener(new pasteListener());
         editMenu.add(pasteItem);
      	
         JMenuItem copyEItem = new JMenuItem("Copy Exact Entry");
         copyEItem.setForeground(Color.white);
         copyEItem.setBackground(Color.blue);
         copyEItem.getAccessibleContext().setAccessibleDescription("Copy Exact Entire Entry");
         copyEItem.addActionListener(new copyEListener());
         editMenu.add(copyEItem);	
      	
         JMenuItem cutEItem = new JMenuItem("Cut Exact Entry");
         cutEItem.setForeground(Color.white);
         cutEItem.setBackground(Color.blue);
         cutEItem.getAccessibleContext().setAccessibleDescription("Cut Exact Entire Entry");
         cutEItem.addActionListener(new cutEListener());
         editMenu.add(cutEItem);	
      	
         JMenuItem pasteEItem = new JMenuItem("Paste Exact Entry");
         pasteEItem.setForeground(Color.white);
         pasteEItem.setBackground(Color.blue);
         pasteEItem.getAccessibleContext().setAccessibleDescription("Paste Exact Entire Entry");
         pasteEItem.addActionListener(new pasteEListener());
         editMenu.add(pasteEItem);			
      	
      	
         JMenu settingsMenu = new JMenu("Settings");
         settingsMenu.setForeground(Color.white);
         settingsMenu.setMnemonic(KeyEvent.VK_S);
         settingsMenu.getAccessibleContext().setAccessibleDescription("Settings Operations");
         add(settingsMenu);
      	
         JMenuItem loginTimerSettingsItem = new JMenuItem("Logged In Timer...", KeyEvent.VK_L);
         loginTimerSettingsItem.setForeground(Color.white);
         loginTimerSettingsItem.setBackground(Color.blue);
         loginTimerSettingsItem.getAccessibleContext().setAccessibleDescription("Login Timer Settings");
         loginTimerSettingsItem.addActionListener(new loginTimerSettingsListener());
         settingsMenu.add(loginTimerSettingsItem);
      	
         JMenuItem decryptTimerSettingsItem = new JMenuItem("Decrypted Timer...", KeyEvent.VK_D);
         decryptTimerSettingsItem.setForeground(Color.white);
         decryptTimerSettingsItem.setBackground(Color.blue);
         decryptTimerSettingsItem.getAccessibleContext().setAccessibleDescription("Decrypt Timer Settings");
         decryptTimerSettingsItem.addActionListener(new decryptTimerSettingsListener());
         settingsMenu.add(decryptTimerSettingsItem);
      	
      	
         JMenu helpMenu = new JMenu("Help");
         helpMenu.setForeground(Color.white);
         helpMenu.setMnemonic(KeyEvent.VK_H);
         helpMenu.getAccessibleContext().setAccessibleDescription("Help Operations");
         add(helpMenu);		
      	
         JMenuItem tutorialItem = new JMenuItem("Tutorial", KeyEvent.VK_T);
         tutorialItem.setForeground(Color.white);
         tutorialItem.setBackground(Color.blue);
         tutorialItem.getAccessibleContext().setAccessibleDescription("User Tutorial");
         tutorialItem.addActionListener(new tutorialListener());
         helpMenu.add(tutorialItem);
      	
         JMenu invis = new JMenu("");
         invis.setMnemonic(KeyEvent.VK_Q);
         add(invis);
      	
         JMenuItem exit = new JMenuItem("", KeyEvent.VK_Q);
         exit.addActionListener(new exitFileListener());
         invis.add(exit);
      }
   	
       private class newFileListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            String fileUser = JOptionPane.showInputDialog("Username?");
            String filePass = JOptionPane.showInputDialog("Password?");	
							
            if(fileUser == null || filePass == null || fileUser.equals("") || filePass.equals(""))
               return;
            if(myPane.userDocs.containsKey(fileUser))
            {
               JOptionPane.showMessageDialog(null, "The file: \"" + fileUser + ".aes\" already exists.  Cannot create new file.");
               return;
            }
            try
            {
               File fileToAdd = new File("Documents" + File.separatorChar + fileUser + ".aes");
               fileToAdd.createNewFile();
               myPane.userDocs.put(fileUser, myPane.sha2.hash(filePass));
               myPane.sha2 = new SHA256(myPane.userDocs);
               myPane.updateUserDocs();
            }
                catch(Exception e2)
               {
                  JOptionPane.showMessageDialog(null, "Error: The file specified may not exist.  Please check to make sure.");
                  return;
               }		
            JOptionPane.showMessageDialog(null, "New file: \"" + fileUser + ".aes\" created!");
         }
      }
   	
       private class openFileListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            File docDirectory = new File("Documents");
            String[] containedFiles = docDirectory.list();
            String fileList = "";
            for(int a = 0; a < containedFiles.length; a++)
            {
               String cur = containedFiles[a];
               if(cur.substring(cur.length() - 4).equals(".aes"))
                  fileList += cur.substring(0, cur.length() - 4) + "\n";
            }        
            String toOpen = JOptionPane.showInputDialog("Choose one of the following files:\n" + fileList);
            myPane.user.setText(toOpen);
            myPane.loggedInTime = 0;
            myPane.decryptedTime = 0;
         }
      }
   	
       private class lastFileListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            myPane.user.setText(myPane.lastUser);
            myPane.loggedInTime = 0;
            myPane.decryptedTime = 0;
         }
      }
   	
       private class deleteFileListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            String fileUser = JOptionPane.showInputDialog("Username?");
            String filePass = JOptionPane.showInputDialog("Password?");
				
            if(fileUser == null || filePass == null || fileUser.equals("") || filePass.equals(""))
               return;		
            boolean passed = (myPane.sha2.pass(fileUser, filePass));
            if(!passed)
            {
               JOptionPane.showMessageDialog(null, "The file: \"" + fileUser + ".aes\" does not exist or the password is not correct.  Cannot delete file.");
               return;
            }
            int result = JOptionPane.showConfirmDialog(null, "Are you sure you want to delete file: \"" + fileUser + ".aes\"?");
            if(result != 0)
               return;
            try
            {
               myPane.userDocs.remove(fileUser);
               myPane.sha2 = new SHA256(myPane.userDocs);
               myPane.updateUserDocs();
               File fileToDelete = new File("Documents" + File.separatorChar + fileUser + ".aes");
               if(fileToDelete.exists())
                  fileToDelete.delete();
            }
                catch(Exception e2)
               {
                  JOptionPane.showMessageDialog(null, "Error: The file specified may not exist.  Please check to make sure.");
                  return;
               }
            JOptionPane.showMessageDialog(null, "File: \"" + fileUser + ".aes\" deleted!");
         }
      }
   	
       private class saveFileListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            //Does nothing; Files are automatically updated.
         }
      }
   	
       private class saveAsFileListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            if(myPane.loggedInTime == 0)
               return;
            String curUser = myPane.userDoc;  
            String fileUser = JOptionPane.showInputDialog("New file name?  (Ignore the extension)");	
									
            if(fileUser == null || fileUser.equals(""))
               return;
            if(myPane.userDocs.containsKey(fileUser))
            {
               JOptionPane.showMessageDialog(null, "The file: \"" + fileUser + ".aes\" already exists.  Cannot create new file.");
               return;
            }
            try
            {
               File fileToAdd = new File("Documents" + File.separatorChar + fileUser + ".aes");
               fileToAdd.createNewFile();
               myPane.userDocs.put(fileUser, myPane.userDocs.get(curUser));
               myPane.sha2 = new SHA256(myPane.userDocs);
               myPane.updateUserDocs();
               myPane.doc.copyDocument(fileToAdd);
               myPane.doc = new Document(fileToAdd);
               myPane.loggedInTime = 0;
               myPane.decryptedTime = 0;
            }
                catch(Exception e2)
               {
                  JOptionPane.showMessageDialog(null, "Error: The file specified may not exist.  Please check to make sure.");
                  return;
               }		
         }
      }
   	
       private class exitFileListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            System.exit(0);
         }
      }
   	
       private class copyListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
				textTransfer.setClipboardContents(myPane.decDesc.getText() + "\nUsername: " + myPane.decUser.getText() + "\nPassword: " + myPane.decPass.getText());
	      }
      }
   	
       private class cutListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
				textTransfer.setClipboardContents(myPane.decDesc.getText() + "\nUsername: " + myPane.decUser.getText() + "\nPassword: " + myPane.decPass.getText());
				myPane.decTimer.stop();
            myPane.decryptedTime = 0.0;
            myPane.decDesc.setText("");
            myPane.decUser.setText("");
            myPane.decPass.setText("");
            myPane.passShowTime.setBackground(Color.red);
            myPane.passShowTime.setForeground(Color.white);
            myPane.passShowTime.setText(myPane.decryptedTime + "");
         }
      }
   	
       private class pasteListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            try
				{
					String pasteIn = textTransfer.getClipboardContents();
            	String[] pieces = pasteIn.split("\n");
            	myPane.encDesc.setText(pieces[0]);
            	myPane.encUser.setText(pieces[1].substring(10));
            	myPane.encPass.setText(pieces[2].substring(10));
				}
					catch (Exception e3)
					{
						JOptionPane.showMessageDialog(null, "Incorrect Input Format!\nInput must be in the form:\n<Description>\nUsername: <Username>\nPassword: <Password>");
					} 
         }
      }
   	
       private class copyEListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            textTransfer.setClipboardContents(myPane.decDesc.getText() + "\n" + myPane.decUser.getText() + "\n" + myPane.decPass.getText());
         }
      }
   	
       private class cutEListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            textTransfer.setClipboardContents(myPane.decDesc.getText() + "\n" + myPane.decUser.getText() + "\n" + myPane.decPass.getText());
            myPane.decTimer.stop();
            myPane.decryptedTime = 0.0;
            myPane.decDesc.setText("");
            myPane.decUser.setText("");
            myPane.decPass.setText("");
            myPane.passShowTime.setBackground(Color.red);
            myPane.passShowTime.setForeground(Color.white);
            myPane.passShowTime.setText(myPane.decryptedTime + "");
         }
      }
   	
       private class pasteEListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            try
				{
					String pasteIn = textTransfer.getClipboardContents();
	            String[] pieces = pasteIn.split("\n");
	            myPane.encDesc.setText(pieces[0]);
	            myPane.encUser.setText(pieces[1]);
	            myPane.encPass.setText(pieces[2]);
   			}
					 catch (Exception e3)
					{
						JOptionPane.showMessageDialog(null, "Incorrect Input Format!\nInput must be in the form:\n<Description>\n<Username>\n<Password>");
					}   
		   }
      }
   	
       private class loginTimerSettingsListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            String in = JOptionPane.showInputDialog("Please specify the \"Logged In\" Timer's countdown time.\nNote: Will reset after exit.");
            try
            {
               myPane.logTime = (Double.parseDouble(in));
            }
                catch(Exception el){}
         }
      }
   	
       private class decryptTimerSettingsListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            String in = JOptionPane.showInputDialog("Please specify the \"Decrypted\" Timer's countdown time.\nNote: Will reset after exit.");
            try
            {
               myPane.decTime = (Double.parseDouble(in));
            }
                catch(Exception el){}
         }
      }
   	
       private class tutorialListener implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
    			try
				{
					String info = "";
					Scanner sc = new Scanner(new File("read me.txt"));
					while(sc.hasNext())
						info += sc.nextLine() + "\n";
						
					JTextArea text = new JTextArea(info);
	            text.setBackground(Color.blue);
	            text.setForeground(Color.white);
					text.setEditable(false);
					text.setLineWrap(true);
					text.setWrapStyleWord(true);
	            text.setFont(new Font("Courier", Font.PLAIN, 12));
					JScrollPane scroll = new JScrollPane(text);
					JPanel readPane = new JPanel(new GridLayout(1,1));
					readPane.setBackground(Color.black);
					readPane.add(scroll);
					
					JFrame readMe = new JFrame("Read Me");
	         	readMe.setSize(610, 650);
	         	readMe.setResizable(true);
	         	readMe.setIconImage(ImageIO.read(new File("password encryptor icon.png")));
	         	readMe.setLocation(300, 300);
	        	 	readMe.setContentPane(readPane);
	        	 	readMe.setVisible(true);
				}
					catch (Exception e4)
					{
						JOptionPane.showMessageDialog(null, "File not found!");
					}				
         }
      }
   }

    class PasswordGUI extends JPanel
   {
      public Document doc;
      public Map<String, String> userDocs;
      public SHA256 sha2;
      public AES aes;
     
	   public JScrollPane listScroller;
      public JList list;
      public JTextField fileName, user, encDesc, encUser, decDesc, decUser, decPass, logInTime, passShowTime;
      public JPasswordField pass, encPass;
      public JButton login, logout, encrpt, remove, decrpt, clear;
      public javax.swing.Timer logTimer = new javax.swing.Timer(100, new LogTimerTask());
      public javax.swing.Timer decTimer = new javax.swing.Timer(100, new DecTimerTask());
      
		public int listIndex, tries;
      public long curTime1, curTime2;
      public double loggedInTime, decryptedTime;
      public String userDoc, passDoc, lastUser;	
      public double logTime = 60.0;
      public double decTime = 5.0;
   		
       public PasswordGUI() throws Exception
      {
         setLayout(new BorderLayout());
         setBackground(Color.black);
         setBorder(new BasicBorders.FieldBorder(Color.black, Color.cyan, Color.cyan, Color.black));
      
         JLabel title = new JLabel("Password Encryptor");
         title.setHorizontalAlignment(SwingConstants.CENTER);
         title.setFont(new Font("Courier", Font.PLAIN, 40));
         title.setForeground(Color.white);
         title.setBackground(Color.black);
         add(title, BorderLayout.NORTH);
      
         add(new LeftPane(), BorderLayout.WEST);
         add(new RightPane(), BorderLayout.CENTER);
         loggedInTime = 0;
         decryptedTime = 0;
      	
         Scanner sc = new Scanner(new File("Documents" + File.separatorChar + "User Documents.aed")); //aed = AES Encrypted Documents
         userDocs = new TreeMap<String, String>();
         while(sc.hasNext())
         {
            String[] userHash = sc.nextLine().split("");
            userDocs.put(userHash[0], userHash[1]);
         }
         sha2 = new SHA256(userDocs);
         lastUser = "";
      }
   
       public void run() throws Exception
      {
         System.out.print("");
         if(loggedInTime == 0)
         {
            logInTime.setText("0.0");
            passShowTime.setText("0.0");
            return;
         }
      	  
         try
         {
            doc = new Document(new File("Documents" + File.separatorChar + userDoc + ".aes")); //aes = AES
         }
             catch(FileNotFoundException e)
            {
               JOptionPane.showMessageDialog(null, "File Not Found!");
            }
      
         String seedString = "";
         for(int numFind = 0; numFind < passDoc.length() && Character.isDigit(passDoc.charAt(numFind)); numFind++)
            seedString += passDoc.charAt(numFind);
         if(seedString.length() == 0)
            seedString = "0";
         aes = new AES(passDoc, Long.parseLong(seedString));
         seedString = "";
      
         list.setEnabled(true);
         encrpt.setEnabled(true);
         remove.setEnabled(true);
         decrpt.setEnabled(true);
         clear.setEnabled(true);				
         list.setListData(doc.getEntries());
         logInTime.setBackground(Color.blue);
         logInTime.setForeground(Color.white);
      
         while(loggedInTime > 0)
         {
            System.out.print("");
         }
      
         Entry[] baseList = {new Entry("Please Login")};
         list.setListData(baseList);
         fileName.setText("Please Login");
         logTimer.stop();
         decTimer.stop();
         loggedInTime = 0.0;
         decryptedTime = 0.0;
         logInTime.setText("0.0");
         passShowTime.setText("0.0");	
         logInTime.setBackground(Color.red);
         logInTime.setForeground(Color.white);
         passShowTime.setBackground(Color.red);
         passShowTime.setForeground(Color.white);
         list.setEnabled(false);
         encrpt.setEnabled(false);
         remove.setEnabled(false);
         decrpt.setEnabled(false);
         clear.setEnabled(false);
         lastUser = userDoc;
         userDoc = "";
         passDoc = "";
         encDesc.setText("");
         encUser.setText("");
         encPass.setText("");
         decDesc.setText("");
         decUser.setText("");
         decPass.setText("");
      }
   	
       public void updateUserDocs() throws Exception
      {
         PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("Documents" + File.separatorChar + "User Documents.aed")));
         for(String s1 : userDocs.keySet())
            out.println(s1 + "" + userDocs.get(s1));		
         out.close();		
      }
   	
       private class LogTimerTask implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            loggedInTime = ((logTime * 10 - ((System.currentTimeMillis() - curTime1) / 100)) / 10.0);
            if(loggedInTime < 0)
            {
               logTimer.stop();
               loggedInTime = 0.0;
            }
            logInTime.setText(loggedInTime + "");
         }
      }
   
       private class DecTimerTask implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
            decryptedTime = ((decTime * 10 - ((System.currentTimeMillis() - curTime2) / 100)) / 10.0);
            if(decryptedTime < 0)
            {
               decTimer.stop();
               decryptedTime = 0.0;
               decDesc.setText("");
               decUser.setText("");
               decPass.setText("");
               passShowTime.setBackground(Color.red);
               passShowTime.setForeground(Color.white);
            }
            passShowTime.setText(decryptedTime + "");
         }
      }
   
       private class LeftPane extends JPanel
      {
          private LeftPane()
         {
            setLayout(new BorderLayout());
            setBackground(Color.black);
         	
				JPanel lowerLeft = new JPanel(new BorderLayout());
				lowerLeft.setBackground(Color.black);
				Border cyanline = BorderFactory.createLineBorder(Color.cyan);
				TitledBorder title = BorderFactory.createTitledBorder(cyanline, "Saved Passwords", TitledBorder.CENTER, TitledBorder.TOP, new Font("Courier", Font.PLAIN, 16), Color.white);
            lowerLeft.setBorder(title);
				add(lowerLeft, BorderLayout.CENTER);
				
				JPanel fnPanel = new JPanel(new BorderLayout());
				fnPanel.setBackground(Color.black);
				add(fnPanel, BorderLayout.NORTH);
				
            fileName = new JTextField("Please Login");
            fileName.setBackground(Color.blue);
            fileName.setForeground(Color.white);
            fileName.setEditable(false);
            fileName.setHorizontalAlignment(SwingConstants.CENTER);
            fileName.setFont(new Font("Courier", Font.PLAIN, 18));
				fnPanel.add(fileName);
							
            JLabel filler1 = new JLabel(" ");
            filler1.setFont(new Font("Courier", Font.PLAIN, 7));
            JLabel filler5 = new JLabel(" ");
            filler5.setFont(new Font("Courier", Font.PLAIN, 7));
            JLabel filler6 = new JLabel("   ");
            JLabel filler7 = new JLabel("   ");
            fnPanel.add(filler1, BorderLayout.NORTH);
            fnPanel.add(filler5, BorderLayout.SOUTH);
            fnPanel.add(filler6, BorderLayout.EAST);
            fnPanel.add(filler7, BorderLayout.WEST);
         	
            Entry[] ents = {new Entry("Please Login")};
            list = new JList(ents);
            list.setForeground(Color.cyan);
            list.setBackground(Color.blue);
            list.setSelectionForeground(Color.blue);
            list.setSelectionBackground(Color.white);
            list.setFont(new Font("Courier", Font.PLAIN, 14));
            list.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
            list.setCellRenderer(new CellRenderer());
            list.setVisibleRowCount(-1);
            list.setSelectedIndex(0);
            list.setEnabled(false);
            list.addListSelectionListener(new Listener0());
            listScroller = new JScrollPane(list);
            listScroller.setPreferredSize(new Dimension(200, 75));
            lowerLeft.add(listScroller, BorderLayout.CENTER);
         
            JLabel filler2 = new JLabel(" ");
            filler2.setFont(new Font("Courier", Font.PLAIN, 7));
            JLabel filler3 = new JLabel("   ");
            JLabel filler4 = new JLabel("   ");
            lowerLeft.add(filler2, BorderLayout.SOUTH);
            lowerLeft.add(filler3, BorderLayout.EAST);
            lowerLeft.add(filler4, BorderLayout.WEST);
         }
      
          private class CellRenderer extends JLabel implements ListCellRenderer 
         {
             public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
            {
               boolean isCat = false;      
               String s = value.toString();
               if(s.charAt(0) == '')
               {
                  isCat = true;
                  s = s.substring(1);
               }
               else
                  s = " " + s;	
               setText(s);
            
               if (isSelected) 
               {
                  setBackground(list.getSelectionBackground());
                  if(isCat)
                     setForeground(Color.black);
                  else
                     setForeground(list.getSelectionForeground());
               }
               else 
               {
                  setBackground(list.getBackground());
                  if(isCat)
                     setForeground(Color.white);
                  else
                     setForeground(list.getForeground());
               }
               setEnabled(list.isEnabled());
               setFont(list.getFont());
               setOpaque(true);
               return this;
            }
         }
      
          private class Listener0 implements ListSelectionListener
         {
             public void valueChanged(ListSelectionEvent e)
            {
               int ind = list.getSelectedIndex();
               if(e.getValueIsAdjusting() == false && ind != -1 && doc.getEntries()[ind].toString().charAt(0) == '')
                  decDesc.setText(" " + doc.getEntries()[ind].toString().substring(1));
               else if(e.getValueIsAdjusting() == false && ind != -1)
                  decDesc.setText(doc.getEntries()[ind].toString());
               decUser.setText("");
               decPass.setText("");
               decTimer.stop();
               decryptedTime = 0.0;
               passShowTime.setBackground(Color.red);
               passShowTime.setForeground(Color.white);
               passShowTime.setText("0.0");
            }
         }
      
      }
   
       private class RightPane extends JPanel
      {
          private RightPane()
         {
            setLayout(new GridLayout(3, 1));
            setBackground(Color.black);
         
            PassPane pp = new PassPane();
            EncryptPane ep = new EncryptPane();
            DecryptPane dp = new DecryptPane();
         
            add(pp);
            add(ep);
            add(dp);	
         }
      
          private class PassPane extends JPanel
         {
             private PassPane()
            {
               setLayout(new BorderLayout());
               setBackground(Color.black);
					Border cyanline = BorderFactory.createLineBorder(Color.cyan);
					TitledBorder title = BorderFactory.createTitledBorder(cyanline, "Login / Logout", TitledBorder.CENTER, TitledBorder.TOP, new Font("Courier", Font.PLAIN, 16), Color.white);
	            setBorder(title);
            
               JLabel filler0 = new JLabel("  ");
               JLabel filler1 = new JLabel(" ");
               filler1.setFont(new Font("Courier", Font.PLAIN, 3));
            
               add(filler0, BorderLayout.WEST);
               add(filler1, BorderLayout.SOUTH);
               add(new PassLeftPane(), BorderLayout.CENTER);
               add(new PassRightPane(), BorderLayout.EAST);
            }
         
             private class PassLeftPane extends JPanel
            {
                private PassLeftPane()
               {
                  setLayout(new GridLayout(6, 1));
                  setBackground(Color.black);
               
                  JLabel usr = new JLabel("Username");
                  usr.setForeground(Color.white);
                  usr.setFont(new Font("Courier", Font.PLAIN, 10));
                  user = new JTextField("");
                  user.setBackground(Color.blue);
                  user.setForeground(Color.white);
                  user.setFont(new Font("Courier", Font.PLAIN, 14));
               
                  JLabel pss = new JLabel("Password");
                  pss.setForeground(Color.white);
                  pss.setFont(new Font("Courier", Font.PLAIN, 10));
                  pass = new JPasswordField("");
                  pass.setBackground(Color.blue);
                  pass.setForeground(Color.white);
                  pass.addActionListener(new LoginListener());
                  pass.setFont(new Font("Courier", Font.PLAIN, 14));
               
                  JLabel timeRemainingLabel = new JLabel("Logged In");
                  timeRemainingLabel.setForeground(Color.white);
                  timeRemainingLabel.setFont(new Font("Courier", Font.PLAIN, 10));
                  timeRemainingLabel.setHorizontalAlignment(SwingConstants.CENTER);
                  logInTime = new JTextField("0.0");
                  logInTime.setBackground(Color.red);
                  logInTime.setForeground(Color.white);
                  logInTime.setFont(new Font("Courier", Font.PLAIN, 14));
                  logInTime.setHorizontalAlignment(SwingConstants.CENTER);
                  logInTime.setEditable(false);
                  
                  JLabel timeShowRemainingLabel = new JLabel("Decrypted");
                  timeShowRemainingLabel.setForeground(Color.white);
                  timeShowRemainingLabel.setFont(new Font("Courier", Font.PLAIN, 10));
                  timeShowRemainingLabel.setHorizontalAlignment(SwingConstants.CENTER);
                  passShowTime = new JTextField("0.0");
                  passShowTime.setBackground(Color.red);
                  passShowTime.setForeground(Color.white);
                  passShowTime.setFont(new Font("Courier", Font.PLAIN, 14));
                  passShowTime.setHorizontalAlignment(SwingConstants.CENTER);
                  passShowTime.setEditable(false);
                  
                  JPanel timeLabelPane = new JPanel();
                  timeLabelPane.setBackground(Color.black);
                  timeLabelPane.setLayout(new GridLayout(1, 2));
                  timeLabelPane.add(timeRemainingLabel);
                  timeLabelPane.add(timeShowRemainingLabel);
                  JPanel timeShowPane = new JPanel();
                  timeShowPane.setBackground(Color.black);
                  timeShowPane.setLayout(new GridLayout(1, 2));
                  timeShowPane.add(logInTime, BorderLayout.WEST);
                  timeShowPane.add(passShowTime, BorderLayout.EAST);
               
                  add(usr);
                  add(user);
                  add(pss);
                  add(pass);
                  add(timeLabelPane);
                  add(timeShowPane);
               }
            }
         
             private class PassRightPane extends JPanel
            {
                private PassRightPane()
               {
                  setLayout(new BorderLayout());
                  setBackground(Color.black);
               
                  login = new JButton(" Login ");
                  login.setBackground(Color.cyan);
                  login.setForeground(Color.red);
                  login.setFont(new Font("Courier", Font.PLAIN, 14));
                  login.addActionListener(new LoginListener());
               
                  logout = new JButton("Logout");
                  logout.setBackground(Color.cyan);
                  logout.setForeground(Color.red);
                  logout.setFont(new Font("Courier", Font.PLAIN, 14));
                  logout.addActionListener(new LogoutListener());
						
                  JLabel filler0 = new JLabel(" ");
                  filler0.setFont(new Font("Courier", Font.PLAIN, 7));
                  filler0.setBackground(Color.black);
                  JLabel filler1 = new JLabel(" ");
                  filler1.setFont(new Font("Courier", Font.PLAIN, 12));
                  filler1.setBackground(Color.black);
                  JLabel filler2 = new JLabel(" ");
                  filler2.setFont(new Font("Courier", Font.PLAIN, 7));
                  filler2.setBackground(Color.black);
                  JLabel filler3 = new JLabel(" ");
                  filler3.setFont(new Font("Courier", Font.PLAIN, 3));
                  filler3.setBackground(Color.black);
                  JLabel filler4 = new JLabel(" ");
                  filler4.setFont(new Font("Courier", Font.PLAIN, 7));
                  filler4.setBackground(Color.black);
               
                  JPanel inset = new JPanel();
                  inset.setLayout(new GridLayout(3,1));
                  inset.setBackground(Color.black);
                  inset.add(login);
                  inset.add(filler0);
                  inset.add(logout);
               
                  add(inset, BorderLayout.CENTER);
                  add(filler1, BorderLayout.NORTH);
                  add(filler2, BorderLayout.EAST);
                  add(filler3, BorderLayout.SOUTH);
                  add(filler4, BorderLayout.WEST);
               }
            }
         
             private class LoginListener implements ActionListener
            {
                public void actionPerformed(ActionEvent e)
               {						
                  userDoc = user.getText();
                  char[] pdorig = pass.getPassword();
                  passDoc = "";
                  for(char c : pdorig)
                     passDoc += c + "";
                  user.setText("");
                  pass.setText("");
                  boolean passed = (sha2.pass(userDoc, passDoc));
               					
                  if(!passed)
                  {
                     JOptionPane.showMessageDialog(null, "Incorrect Login -- Access Denied!");
                     tries++;
                     if(tries >= 3)
                     {
                        BareBonesBrowserLaunch.openURL("http://www.bringvictory.com");
                        JOptionPane.showMessageDialog(null, "Too many incorrect guesses!");
                        System.exit(0);
                     }
                     return;
                  }		
                  fileName.setText(userDoc);
                  tries = 0;
                  loggedInTime = logTime;
                  curTime1 = System.currentTimeMillis();
                  logTimer.start();
               }
            }
         
             private class LogoutListener implements ActionListener
            {
                public void actionPerformed(ActionEvent e)
               {
                  loggedInTime = 0;
                  decryptedTime = 0;
               }
            }
         }
      
          private class EncryptPane extends JPanel
         {
             private EncryptPane()
            {
               setLayout(new BorderLayout());
               setBackground(Color.black);
					Border cyanline = BorderFactory.createLineBorder(Color.cyan);
					TitledBorder title = BorderFactory.createTitledBorder(cyanline, "Encrypt", TitledBorder.CENTER, TitledBorder.TOP, new Font("Courier", Font.PLAIN, 16), Color.white);
	            setBorder(title);
					
               JLabel filler0 = new JLabel("  ");
               JLabel filler1 = new JLabel(" ");
               filler1.setFont(new Font("Courier", Font.PLAIN, 3));
            
               add(filler0, BorderLayout.WEST);
               add(filler1, BorderLayout.SOUTH);
               add(new EncLeftPane(), BorderLayout.CENTER);
               add(new EncRightPane(), BorderLayout.EAST);
            }
         
             private class EncLeftPane extends JPanel
            {
                private EncLeftPane()
               {
                  setLayout(new GridLayout(6, 1));
                  setBackground(Color.black);
               
                  JLabel ttl = new JLabel("Category / Description");
                  ttl.setForeground(Color.white);
                  ttl.setFont(new Font("Courier", Font.PLAIN, 10));
               
                  encDesc = new JTextField("");
                  encDesc.setBackground(Color.blue);
                  encDesc.setForeground(Color.white);
                  encDesc.setFont(new Font("Courier", Font.PLAIN, 14));
               
                  JLabel usr = new JLabel("Username");
                  usr.setForeground(Color.white);
                  usr.setFont(new Font("Courier", Font.PLAIN, 10));
               
                  encUser = new JTextField("");
                  encUser.setBackground(Color.blue);
                  encUser.setForeground(Color.white);
                  encUser.setFont(new Font("Courier", Font.PLAIN, 14));
               
                  JLabel pss = new JLabel("Password");
                  pss.setForeground(Color.white);
                  pss.setFont(new Font("Courier", Font.PLAIN, 10));
               
                  encPass = new JPasswordField("");
                  encPass.setBackground(Color.blue);
                  encPass.setForeground(Color.white);
                  encPass.setFont(new Font("Courier", Font.PLAIN, 14));
               
                  add(ttl);
                  add(encDesc);
                  add(usr);
                  add(encUser);
                  add(pss);
                  add(encPass);
               }
            }
         
             private class EncRightPane extends JPanel
            {
                private EncRightPane()
               {
                  setLayout(new BorderLayout());
                  setBackground(Color.black);
               
                  encrpt = new JButton("Encrypt");
                  encrpt.setBackground(Color.cyan);
                  encrpt.setForeground(Color.red);
                  encrpt.setEnabled(false);
                  encrpt.setFont(new Font("Courier", Font.PLAIN, 14));
                  encrpt.addActionListener(new EncListener());
               
                  remove = new JButton("Remove");
                  remove.setBackground(Color.cyan);
                  remove.setForeground(Color.red);
                  remove.setEnabled(false);
                  remove.setFont(new Font("Courier", Font.PLAIN, 14));
                  remove.addActionListener(new RemListener());
               
                  JLabel filler0 = new JLabel(" ");
                  filler0.setFont(new Font("Courier", Font.PLAIN, 7));
                  filler0.setBackground(Color.black);
                  JLabel filler1 = new JLabel(" ");
                  filler1.setFont(new Font("Courier", Font.PLAIN, 12));
                  filler1.setBackground(Color.black);
                  JLabel filler2 = new JLabel(" ");
                  filler2.setFont(new Font("Courier", Font.PLAIN, 7));
                  filler2.setBackground(Color.black);
                  JLabel filler3 = new JLabel(" ");
                  filler3.setFont(new Font("Courier", Font.PLAIN, 3));
                  filler3.setBackground(Color.black);
                  JLabel filler4 = new JLabel(" ");
                  filler4.setFont(new Font("Courier", Font.PLAIN, 7));
                  filler4.setBackground(Color.black);
               
                  JPanel inset = new JPanel();
                  inset.setLayout(new GridLayout(3,1));
                  inset.setBackground(Color.black);
                  inset.add(encrpt);
                  inset.add(filler0);
                  inset.add(remove);
               
                  add(inset, BorderLayout.CENTER);
                  add(filler1, BorderLayout.NORTH);
                  add(filler2, BorderLayout.EAST);
                  add(filler3, BorderLayout.SOUTH);
                  add(filler4, BorderLayout.WEST);
               	
               }
            
                private class EncListener implements ActionListener
               {
                   public void actionPerformed(ActionEvent e)
                  {
                     String encD = encDesc.getText();
                     String encU = encUser.getText();
                     String encP = "";
                     if(encD.equals(""))
                        return;
                     char[] encPchar = encPass.getPassword();
                     for(char c : encPchar)
                        encP += c;
                     Entry toAdd = new Entry(encD, aes.encrypt(encU, doc.size() + 1), aes.encrypt(encP, doc.size() + 1), doc.size() + 1);
                     if(encU.equals("") && encP.equals(""))
                        toAdd = new Entry("" + encD);
                     int listIndexCur = list.getSelectedIndex();
                     if(listIndexCur < 0)
                        listIndexCur = 0;
                  
                     try
                     {
                        doc.add(listIndexCur, toAdd);
                     }
                         catch(Exception ex){}
                  
                     list.setListData(doc.getEntries());
                     encD = "";
                     encU = "";
                     encP = ""; 
                     encDesc.setText("");
                     encUser.setText("");
                     encPass.setText("");
                  }
               }
            
                private class RemListener implements ActionListener
               {
                   public void actionPerformed(ActionEvent e)
                  {
                     if(list.getSelectedIndex() < 0)
                        return;
                     int result = JOptionPane.showConfirmDialog(null, "Are you sure you want to delete the selected entry?");
                     if(result != 0)
                        return;
                  
                     try
                     {
                        doc.remove(list.getSelectedIndex());  
                     }
                         catch(Exception ex){}
                  
                     list.setListData(doc.getEntries());   
                  }
               }
            }
         }
      
          private class DecryptPane extends JPanel
         {
             private DecryptPane()
            {
               setLayout(new BorderLayout());
               setBackground(Color.black);
					Border cyanline = BorderFactory.createLineBorder(Color.cyan);
					TitledBorder title = BorderFactory.createTitledBorder(cyanline, "Decrypt", TitledBorder.CENTER, TitledBorder.TOP, new Font("Courier", Font.PLAIN, 16), Color.white);
	            setBorder(title);
					
               JLabel filler0 = new JLabel("  ");
               JLabel filler1 = new JLabel(" ");
               filler1.setFont(new Font("Courier", Font.PLAIN, 3));
            
               add(filler0, BorderLayout.WEST);
               add(filler1, BorderLayout.SOUTH);
               add(new DecLeftPane(), BorderLayout.CENTER);
               add(new DecRightPane(), BorderLayout.EAST);
            }
         
             private class DecLeftPane extends JPanel
            {
                private DecLeftPane()
               {
                  setLayout(new GridLayout(6, 1));
                  setBackground(Color.black);
               
                  JLabel ttl = new JLabel("Description");
                  ttl.setForeground(Color.white);
                  ttl.setFont(new Font("Courier", Font.PLAIN, 10));
               
                  decDesc = new JTextField("");
                  decDesc.setBackground(Color.blue);
                  decDesc.setForeground(Color.white);
                  decDesc.setFont(new Font("Courier", Font.PLAIN, 14));
                  decDesc.setEditable(false);
               
                  JLabel usr = new JLabel("Username");
                  usr.setForeground(Color.white);
                  usr.setFont(new Font("Courier", Font.PLAIN, 10));
               
                  decUser = new JTextField("");
                  decUser.setBackground(Color.blue);
                  decUser.setForeground(Color.white);
                  decUser.setFont(new Font("Courier", Font.PLAIN, 14));
                  decUser.setEditable(false);
               
                  JLabel pss = new JLabel("Password");
                  pss.setForeground(Color.white);
                  pss.setFont(new Font("Courier", Font.PLAIN, 10));
               
                  decPass = new JTextField("");
                  decPass.setBackground(Color.blue);
                  decPass.setForeground(Color.white);
                  decPass.setFont(new Font("Courier", Font.PLAIN, 14));
                  decPass.setEditable(false);
               
                  add(ttl);
                  add(decDesc);
                  add(usr);
                  add(decUser);
                  add(pss);
                  add(decPass);
               }
            }
         
             private class DecRightPane extends JPanel
            {
                private DecRightPane()
               {
                  setLayout(new BorderLayout());
                  setBackground(Color.black);
               
                  decrpt = new JButton("Decrypt");
                  decrpt.setBackground(Color.cyan);
                  decrpt.setForeground(Color.red);
                  decrpt.setEnabled(false);
                  decrpt.setFont(new Font("Courier", Font.PLAIN, 14));
                  decrpt.addActionListener(new DecListener());
               
                  clear = new JButton("Clear");
                  clear.setBackground(Color.cyan);
                  clear.setForeground(Color.red);
                  clear.setEnabled(false);
                  clear.setFont(new Font("Courier", Font.PLAIN, 14));
                  clear.addActionListener(new ClrListener());
               
                  JLabel filler0 = new JLabel(" ");
                  filler0.setFont(new Font("Courier", Font.PLAIN, 7));
                  filler0.setBackground(Color.black);
                  JLabel filler1 = new JLabel(" ");
                  filler1.setFont(new Font("Courier", Font.PLAIN, 12));
                  filler1.setBackground(Color.black);
                  JLabel filler2 = new JLabel(" ");
                  filler2.setFont(new Font("Courier", Font.PLAIN, 7));
                  filler2.setBackground(Color.black);
                  JLabel filler3 = new JLabel(" ");
                  filler3.setFont(new Font("Courier", Font.PLAIN, 3));
                  filler3.setBackground(Color.black);
                  JLabel filler4 = new JLabel(" ");
                  filler4.setFont(new Font("Courier", Font.PLAIN, 7));
                  filler4.setBackground(Color.black);
               
                  JPanel inset = new JPanel();
                  inset.setLayout(new GridLayout(3,1));
                  inset.setBackground(Color.black);
                  inset.add(decrpt);
                  inset.add(filler0);
                  inset.add(clear);
               
                  add(inset, BorderLayout.CENTER);
                  add(filler1, BorderLayout.NORTH);
                  add(filler2, BorderLayout.EAST);
                  add(filler3, BorderLayout.SOUTH);
                  add(filler4, BorderLayout.WEST);
               	
               }
            
                private class DecListener implements ActionListener
               {
                   public void actionPerformed(ActionEvent e)
                  {
                     if(list.getSelectedIndex() < 0)
                        return;
                     Entry curEntry = (doc.getEntries())[list.getSelectedIndex()];
                     if(!curEntry.isCategory())
                     {
                        String decU = aes.decrypt(curEntry.getUser(), curEntry.getIndex());
                        String decP = aes.decrypt(curEntry.getPass(), curEntry.getIndex());
                        decDesc.setText(curEntry.toString());
                        decUser.setText(decU);
                        decPass.setText(decP);
                        decU = "";
                        decP = "";
                     }
                     else
                     {
                        decDesc.setText(" " + curEntry.toString().substring(1));
                        decUser.setText("");
                        decPass.setText("");
                     }
                     passShowTime.setBackground(Color.blue);
                     passShowTime.setForeground(Color.white);
                     decryptedTime = decTime;
                     curTime2 = System.currentTimeMillis();
                     decTimer.start();
                  }
               }
            
                private class ClrListener implements ActionListener
               {
                   public void actionPerformed(ActionEvent e)
                  {
                     user.setText("");
                     pass.setText("");
                     encDesc.setText("");
                     encUser.setText("");
                     encPass.setText("");
                     decDesc.setText("");
                     decUser.setText("");
                     decPass.setText("");
                     decTimer.stop();
                     decryptedTime = 0.0;
                     decDesc.setText("");
                     decUser.setText("");
                     decPass.setText("");
                     passShowTime.setBackground(Color.red);
                     passShowTime.setForeground(Color.white);
                     passShowTime.setText("0.0");
                  }
               }
            }
         }
      }	
   }

    class Entry implements Comparable<Entry>
   {
      private String title;
      private String encUser;
      private String encPass;
      private int myIndex;
      private boolean category;
   
       public Entry(String t)
      {
         if(t.charAt(0) != '')
            t = "" + t;
         title = t;
         category = true;
      }
   
       public Entry(String t, String u, String p, int i)
      {
         title = t;
         encUser = u;
         encPass = p;
         myIndex = i;
      }
   
       public String getTitle()
      {
         return title;
      }
   
       public String getUser()
      {
         return encUser;
      }
   
       public String getPass()
      {
         return encPass;
      }
   	
       public int getIndex()
      {
         return myIndex;
      }
   
       public boolean isCategory()
      {
         return category;
      }
   
       public String toString()
      {
         return title;
      }
   
       public int compareTo(Entry en)
      {
         return title.compareTo(en.title);
      }
   }

    class Document
   {
      private TreeMap<Entry, TreeSet<Entry>> mainDoc;
      private ArrayList<Entry> entries;
      private File myFile;
      private int mySize;
      private char parseBy = '';
      private char catBy = '';
   
       public Document(File file) throws Exception
      {
         mySize = 0;
         myFile = file;
         if(!myFile.exists())
         {
            JOptionPane.showMessageDialog(null, "The file: \"" + myFile.getName() + "\" does not exist.");
            System.exit(0);  
         }
         Scanner sc = new Scanner(myFile);
         entries = new ArrayList<Entry>();
         ArrayList<String> entryTitles = new ArrayList<String>();
         mainDoc = new TreeMap<Entry, TreeSet<Entry>>();
         int curInd = 0;
         Entry curCat = null;
      
         while(sc.hasNext())
         {
            String[] curStrings = sc.nextLine().split(parseBy + "");
            if(curStrings.length == 1)
               mainDoc.put(new Entry(curStrings[0]), new TreeSet<Entry>());
            else if(curStrings[0].charAt(0) == catBy)
               for(String s : curStrings)
                  entryTitles.add(s);			
            else
            {
               String entryTitle = entryTitles.get(curInd);
               if(entryTitle.charAt(0) == catBy)
               {
                  curCat = new Entry(entryTitle);
                  mainDoc.put(curCat, new TreeSet<Entry>());
                  curInd++;
                  entryTitle = entryTitles.get(curInd);
               }		
               String entryUser = curStrings[0];
               String entryPass = curStrings[1];
               int entryInd = Integer.parseInt(curStrings[2]);
               mySize = Math.max(mySize, entryInd);
               mainDoc.get(curCat).add(new Entry(entryTitle, entryUser, entryPass, entryInd));				
               curInd++;
            }
         }
         updateEntries();
      }
   
       public Entry[] getEntries()
      {
         Entry[] ents = new Entry[entries.size()];
         int ind = 0;
         for(Entry e : entries)
            ents[ind++] = e;
         return ents;
      }
      
       public int size()
      {
         return mySize;
      }
   
       public void add(int index, Entry en) throws Exception
      {
         if(en.isCategory())
         {
            if(mainDoc.containsKey(en))
               return;
            mainDoc.put(en, new TreeSet<Entry>());
         }
         else
         {
            if(index < 0 || index >= entries.size())
               return;
            Entry categ = whatCat(index);
            if(mainDoc.get(categ).contains(en))
            {
               int result = JOptionPane.showConfirmDialog(null, "The Entry: \"" + en.toString() + "\" already exists.  Overwrite \"" + en.toString() + "\"?");
               if(result != 0)
                  return;
            }
            mainDoc.get(categ).add(en);
            mySize = Math.max(mySize, en.getIndex());
         }		
         updateEntries();
         updateDocument();
      }
   
       public void remove(int index) throws Exception
      {
         if(index < 0 || index >= entries.size())
            return;
         Entry en = entries.get(index);
         if(en.isCategory())
         {
            int result = JOptionPane.showConfirmDialog(null, "Remove entire category: \"" + en.toString().substring(1) + "\"?");
            if(result != 0)
               return;
            mainDoc.remove(en);
         }
         else
            mainDoc.get(whatCat(index)).remove(en);
         updateEntries();
         updateDocument();
      }
   
       private Entry whatCat(int index)
      {
         if(index < 0 || index >= entries.size())
            return null;
         for(int a = index; a >= 0; a--)
         {
            if(entries.get(a).isCategory())
               return entries.get(a);
         }
         return null;
      }
   
       private void updateEntries()
      {
         entries = new ArrayList<Entry>();
         for(Entry e1 : mainDoc.keySet())
         {
            entries.add(e1);
            for(Entry e2 : mainDoc.get(e1))
               entries.add(e2);
         }
      }
   
       private void updateDocument() throws Exception
      {
         PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(myFile)));
         for(Entry e1 : mainDoc.keySet())
         {
            out.print(e1.toString());
            for(Entry e2 : mainDoc.get(e1))
               out.print(parseBy + e2.toString());
            out.println();
         }
         for(Entry e1 : mainDoc.keySet())
            for(Entry e2 : mainDoc.get(e1))
               out.println(e2.getUser() + parseBy + e2.getPass() + parseBy + e2.getIndex());
         out.close();
      }
   
       public void copyDocument(File tofile) throws Exception
      {
         PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(tofile)));
         for(Entry e1 : mainDoc.keySet())
         {
            out.print(e1.toString());
            for(Entry e2 : mainDoc.get(e1))
               out.print(parseBy + e2.toString());
            out.println();
         }
         for(Entry e1 : mainDoc.keySet())
            for(Entry e2 : mainDoc.get(e1))
               out.println(e2.getUser() + parseBy + e2.getPass() + parseBy + e2.getIndex());
         out.close();
      }	
   }

    class SHA256
   {
      private Map<String, String> allUsers;
   
       public SHA256(Map<String, String> au)
      {
         allUsers = au;
      }
   
       public boolean pass(String user, String passwd)
      {
         if(!allUsers.containsKey(user))
            return false;
         return hash(passwd).equals(allUsers.get(user));
      }
   
       public String hash(String s)
      {
         int h0 = 0x6a09e667;
         int h1 = 0xbb67ae85;
         int h2 = 0x3c6ef372;
         int h3 = 0xa54ff53a;
         int h4 = 0x510e527f;
         int h5 = 0x9b05688c;
         int h6 = 0x1f83d9ab;
         int h7 = 0x5be0cd19;
         int[] k =  {0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5, 0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
               		0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3, 0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
               		0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc, 0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
               		0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7, 0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
               		0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13, 0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
               		0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3, 0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
               		0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5, 0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
               		0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208, 0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2};
      
         int testRotate = 3;
         testRotate = Integer.rotateRight(testRotate, 1);
         testRotate = testRotate >>> 1;
      
         String len = Long.toBinaryString(s.length());
         s += "1";
         while(s.length() % 512 != 448)
            s += "0";
         while(len.length() < 64)
            len = "0" + len;
         s += len;
      
         while(s.length() >= 64)
         {
            String chunk = s.substring(0, 64);
            s = s.substring(64);
            int[] w = new int[64];
            for(int wd = 0; wd < 16; wd++)
            {
               char[] curWord = chunk.substring(0,4).toCharArray();
               chunk = chunk.substring(4);
               String bit32 = "";
               for(char c : curWord)
                  bit32 += Integer.toBinaryString((int)c);
               w[wd] = Integer.parseInt(bit32, 2);
            }
            for(int i = 16; i < 64; i++)
            {
               int s0 = Integer.rotateRight(w[i-15], 7) ^ Integer.rotateRight(w[i-15], 18) ^ (int)(w[i-15] >>> 3);
               int s1 = Integer.rotateRight(w[i-2], 17) ^ Integer.rotateRight(w[i-2], 19) ^ (int)(w[i-2] >>> 10);
               w[i] = w[i-16] + s0 + w[i-7] + s1;
            }
         
            int a = h0;
            int b = h1;
            int c = h2;
            int d = h3;
            int e = h4;
            int f = h5;
            int g = h6;
            int h = h7;
         
            for(int i = 0; i < 64; i++)
            {
               int s0 = (Integer.rotateRight(a, 2)) ^ (Integer.rotateRight(a, 13)) ^ (Integer.rotateRight(a, 22));
               int maj = (a & b) ^ (a & c) ^ (b & c);
               int t2 = s0 + maj;
               int s1 = (Integer.rotateRight(e, 6)) ^ (Integer.rotateRight(e, 11)) ^ (Integer.rotateRight(e, 25));
               int ch = (e & f) ^ ((~e) & g);
               int t1 = h + s1 + ch + k[i] + w[i];
            
               h = g;
               g = f;
               f = e;
               e = d + t1;
               d = c;
               c = b;
               b = a;
               a = t1 + t2;
            }
         
            h0 = h0 + a;
            h1 = h1 + b; 
            h2 = h2 + c;
            h3 = h3 + d;
            h4 = h4 + e;
            h5 = h5 + f;
            h6 = h6 + g;
            h7 = h7 + h;
         }
      
         String hex0 = Integer.toHexString(h0);
         while(hex0.length() < 8)
            hex0 = "0" + hex0;
         String hex1 = Integer.toHexString(h1);
         while(hex1.length() < 8)
            hex1 = "0" + hex1;
         String hex2 = Integer.toHexString(h2);
         while(hex2.length() < 8)
            hex2 = "0" + hex2;
         String hex3 = Integer.toHexString(h3);
         while(hex3.length() < 8)
            hex3 = "0" + hex3;
         String hex4 = Integer.toHexString(h4);
         while(hex4.length() < 8)
            hex4 = "0" + hex4;
         String hex5 = Integer.toHexString(h5);
         while(hex5.length() < 8)
            hex5 = "0" + hex5;
         String hex6 = Integer.toHexString(h6);
         while(hex6.length() < 8)
            hex6 = "0" + hex6;
         String hex7 = Integer.toHexString(h7);
         while(hex7.length() < 8)
            hex7 = "0" + hex7;
      
         return ((hex0) + (hex1) + (hex2) + (hex3) + (hex4) + (hex5) + (hex6) + (hex7));		
      }
   }

    class AES
   {
      private int[][][] keys;
      private int[][] sBox;
      private long seed;
   
       public AES(String k, long s)
      {
         seed = s;
         sBox = randomize(seed);
         while(k.length() < 16)
            k += k;
         String key = k.substring(0, 16);
         keys = new int[11][4][4];
         keyFill(keys, key);
         key = "";
      }
   
       public String encrypt(String s, int part)
      {
         String result = "";	
         sBox = randomize(seed * (part + 20) + 12);	
      	
         while(s.length() > 0)
         {
            while(s.length() < 16)
               s += "\0";
            char[] curChars = s.substring(0,16).toCharArray();
            int[] cur = new int[16];
            int ind = 0;
            for(char c : curChars)
               cur[ind++] = (int)c;
            s = s.substring(16);
            int[][] input = new int[4][4];
            for(int c = 0; c < 4; c++)
               for(int r = 0; r < 4; r++)
                  input[r][c] = cur[4*c + r];
         
            addRoundKey(input, keys[0]);
            for(int a = 1; a < 10; a++)
            {
               substitute(input, true);
               shift(input, true);
               diffuse(input, true);
               addRoundKey(input, keys[a]);
            }
            substitute(input, true);
            shift(input, true);
            addRoundKey(input, keys[10]);
         			
            for(int c = 0; c < 4; c++)
               for(int r = 0; r < 4; r++)
                  result += (char)input[r][c];
         }
         return toHex(result);
      }
   
       public String decrypt(String s, int part)
      {
         String result = "";
         s = toChar(s);   
         sBox = randomize(seed * (part + 20) + 12);	
      
         while(s.length() > 0)
         {
            char[] curChars = s.substring(0,16).toCharArray();
            int[] cur = new int[16];
            int ind = 0;
            for(char c : curChars)
               cur[ind++] = (int)c;
            s = s.substring(16);
            int[][] input = new int[4][4];
            for(int c = 0; c < 4; c++)
               for(int r = 0; r < 4; r++)
                  input[r][c] = cur[4*c + r];
         
            addRoundKey(input, keys[10]);
            shift(input, false);
            substitute(input, false);
            for(int a = 9; a > 0; a--)
            {
               addRoundKey(input, keys[a]);
               diffuse(input, false);
               shift(input, false);
               substitute(input, false);
            }
            addRoundKey(input, keys[0]);
         
            for(int c = 0; c < 4; c++)
               for(int r = 0; r < 4; r++)
                  if(input[r][c] != 0)
                     result += (char)input[r][c];
         }
         return result;
      }
   
       private void keyFill(int[][][] keys, String key)
      {
         int ind = 0;
         for(int c = 0; c < 4; c++)
            for(int r = 0; r < 4; r++)
               keys[0][r][c] = key.charAt(ind++);
      
         int[] roundConstant = {1, 0, 0, 0};
      
         for(int a = 1; a <= 10; a++)
         {
            for(int it = 0; it < 4; it++)
               keys[a][it][0] = keys[a - 1][it][0] ^ (sBox[0][keys[a - 1][(it + 1) % 4][3]] ^ roundConstant[it]);
            for(int c = 1; c < 4; c++)
               for(int r = 0; r < 4; r++)
                  keys[a][r][c] = keys[a][r][c - 1] ^ keys[a - 1][r][c];
            roundConstant[0] = rMult(roundConstant[0], 2);
         }		
      }
   
       private int[][] randomize(long seed)
      {
         CryptRandom rand = new CryptRandom(seed);
         int[][] result = new int[2][256];
         ArrayList<Integer> ints = new ArrayList<Integer>();
         ArrayList<Integer> grab = new ArrayList<Integer>();
         for(int a = 0; a < 256; a++)
            grab.add(a);			
         for(int a = 256; a > 0; a--)
         {
            int rnd = (int)(rand.nextDouble() * a);
            ints.add(grab.get(rnd));
            grab.remove(rnd);
         }
         int ind = 0;
         for(int i : ints)
            result[0][ind++] = i;
         for(int i = 0; i < 256; i++)
            result[1][i] = ints.indexOf(i);
         return result;
      }
   
       private void addRoundKey(int[][] input, int[][] thisKey)
      {
         for(int r = 0; r < 4; r++)
            for(int c = 0; c < 4; c++)
               input[r][c] = (input[r][c] ^ thisKey[r][c]);
      }
   
       private void substitute(int[][] input, boolean encrypt)
      {
         int ver = 0;
         if(!encrypt)
            ver = 1;
         for(int r = 0; r < 4; r++)
            for(int c = 0; c < 4; c++)
               input[r][c] = sBox[ver][input[r][c]];
      }
   
       private void shift(int[][] input, boolean encrypt)
      {
         for(int r = 1; r < 4; r++)
         {
            int[] temp = new int[4];
            for(int a = 0; a < 4; a++)
               temp[a] = input[r][a];
            int shiftBy = 4 - r;
            if(!encrypt)
               shiftBy = r;
            for(int c = 3; c >= 0; c--)
               input[r][c] = temp[((4 + c - shiftBy) % 4)];
         }
      }
   
       private void diffuse(int[][] input, boolean encrypt)
      {
         if(encrypt)
         {
            for(int c = 0; c < 4; c++) //apply MixMatrix
            {
               int a0 = input[0][c];
               int a1 = input[1][c];
               int a2 = input[2][c];
               int a3 = input[3][c];
               input[0][c] = rMult(2, a0) ^ rMult(3, a1) ^ a2 ^ a3;
               input[1][c] = rMult(2, a1) ^ rMult(3, a2) ^ a3 ^ a0;
               input[2][c] = rMult(2, a2) ^ rMult(3, a3) ^ a0 ^ a1;
               input[3][c] = rMult(2, a3) ^ rMult(3, a0) ^ a1 ^ a2;				
            }			
            return;
         }
         for(int c = 0; c < 4; c++) //apply inverse of MixMatrix
         {
            int a0 = input[0][c];
            int a1 = input[1][c];
            int a2 = input[2][c];
            int a3 = input[3][c];
            input[0][c] = rMult(14, a0) ^ rMult(9, a3) ^ rMult(13, a2) ^ rMult(11, a1);
            input[1][c] = rMult(14, a1) ^ rMult(9, a0) ^ rMult(13, a3) ^ rMult(11, a2);
            input[2][c] = rMult(14, a2) ^ rMult(9, a1) ^ rMult(13, a0) ^ rMult(11, a3);
            input[3][c] = rMult(14, a3) ^ rMult(9, a2) ^ rMult(13, a1) ^ rMult(11, a0);
         }
      }
   
       private int rMult(int a, int b) //Rijndael's Finite Field Multiply
      {
         int p = 0;
         for(int i = 0; i < 8; i++)
         {
            if((b & 0x01) == 0x01)
               p = p ^ a;
            boolean h = ((a & 0x80) == 0x80);
            a = (a * 2 % 256);
            if(h)
               a = a ^ (0x1b);
            b /= 2;
         }
         return p;
      }
   
       private String toHex(String s)
      {
         String result = "";
         char[] cArr = s.toCharArray();
         for(char c : cArr)
         {
            String curHex = Integer.toHexString((int)c);
            while(curHex.length() < 2)
               curHex = "0" + curHex;
            result += curHex;
         }
         return result;
      }
   
       private String toChar(String s)
      {
         String result = "";
         while(s.length() >= 2)
         {
            String curHexChar = s.substring(0,2);
            s = s.substring(2);
            char curChar = (char)(Integer.parseInt(curHexChar, 16));
            result += curChar;
         }
         return result;
      }
   }
	
    class CryptRandom //Based on java's Random class
   {
      private long seed;
      private static final long multiplier = 0x5deece66dL;
   	
       public CryptRandom(long s)
      {
         setSeed(s);
      }
   	
       public synchronized void setSeed(long seed) 
      {
         this.seed = (seed ^ multiplier) & ((1L << 48) - 1);
      }
   	
       protected synchronized int next(int bits)
      {
         seed = (seed * multiplier + 0xbL) & ((1L << 48) - 1);
         return (int)(seed >>> (48 - bits));
      }
   	
       public double nextDouble()
      {
         return ((((long)next(26) << 27) + next(27)) / (double)(1L << 53));
      }
   }
	
    class TextTransfer implements ClipboardOwner //Thanks to: http://www.javapractices.com/topic/TopicAction.do?Id=82
   {
       public void lostOwnership( Clipboard aClipboard, Transferable aContents) {}
   
       public void setClipboardContents( String aString )
      {
         StringSelection stringSelection = new StringSelection( aString );
         Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
         clipboard.setContents( stringSelection, this );
      }
   
       public String getClipboardContents() 
      {
         String result = "";
         Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
         Transferable contents = clipboard.getContents(null);
         boolean hasTransferableText = (contents != null) && contents.isDataFlavorSupported(DataFlavor.stringFlavor);
         if(hasTransferableText)
         {
            try 
            {
               result = (String)contents.getTransferData(DataFlavor.stringFlavor);
            }
                catch (UnsupportedFlavorException ex)
               {
                  System.out.println(ex);
                  ex.printStackTrace();
               }
                catch (IOException ex) 
               {
                  System.out.println(ex);
                  ex.printStackTrace();
               }
         }
         return result;
      }
   }
   
    class BareBonesBrowserLaunch //thanks to: http://www.centerkey.com/java/browser/
   {
      static final String[] browsers = {"google-chrome", "firefox", "opera", "epiphany", "konqueror", "conkeror", "midori", "kazehakase", "mozilla"}; 
      static final String errMsg = "Error attempting to launch web browser"; 
       public static void openURL(String url)
      { 
         try
         {
            Class<?> d = Class.forName("java.awt.Desktop"); 
            d.getDeclaredMethod("browse", new Class[] {java.net.URI.class}).invoke(d.getDeclaredMethod("getDesktop").invoke(null), new Object[] {java.net.URI.create(url)});
         } 
             catch (Exception ignore) 
            {
               String osName = System.getProperty("os.name"); 
               try
               { 
                  if(osName.startsWith("Mac OS")) 
                     Class.forName("com.apple.eio.FileManager").getDeclaredMethod("openURL", new Class[] {String.class}).invoke(null, new Object[] {url});
                  else if(osName.startsWith("Windows")) 
                     Runtime.getRuntime().exec("rundll32 url.dll,FileProtocolHandler " + url); 
                  else
                  {
                     String browser = null; 
                     for(String b : browsers) 
                        if(browser == null && Runtime.getRuntime().exec(new String[]{"which", b}).getInputStream().read() != -1) 
                           Runtime.getRuntime().exec(new String[] {browser = b, url}); 
                     if(browser == null) 
                        throw new Exception(Arrays.toString(browsers));
                  }
               } 
                   catch(Exception e) 
                  {
                     JOptionPane.showMessageDialog(null, errMsg + "\n" + e.toString());
                  }
            }
      }
   }

//The End